//+------------------------------------------------------------------+
//|                                       ind_AverageValPrice_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 White
#property indicator_color4 Aqua


#property indicator_level1 1

//---- input parameters
extern int       ExtParam1;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);   
   
   
   SetIndexLabel(0," GBP");
   SetIndexLabel(1," JPY");   
   SetIndexLabel(2," GBP/JPY");      
   SetIndexLabel(3," GBP/JPY");     
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit=Bars-IndicatorCounted();
   
         //, GBPJPY
         
         // GBP  GBPUSD, GBPCHF
         // JPY  USDJPY, CHFJPY
   
         for(int i=limit-1;i>=0;i--){
         
            int bn1=iBarShift("GBPUSD",0,Time[i],false);
            int bn2=iBarShift("GBPCHF",0,Time[i],false);  
            int bn3=iBarShift("USDJPY",0,Time[i],false);              
            int bn4=iBarShift("CHFJPY",0,Time[i],false);                       
            int bn5=iBarShift("GBPJPY",0,Time[i],false);               
         
            double m1=iMA("GBPUSD",0,90,0,0,0,bn1);
            double m2=iMA("GBPCHF",0,90,0,0,0,bn2);  
            if(m1==0 || m2==0)continue;          
            double v1=iClose("GBPUSD",0,bn1)/m1;
            double v2=iClose("GBPCHF",0,bn2)/m2;
            double v12a=(v1+v2)/2;
            ExtMapBuffer1[i]=v12a;// GBP
            
            
            m1=iClose("USDJPY",0,bn3);
            m2=iClose("CHFJPY",0,bn4);  
            if(m1==0 || m2==0)continue;  
            v1=iMA("USDJPY",0,90,0,0,0,bn3)/m1;
            v2=iMA("CHFJPY",0,90,0,0,0,bn4)/m2;
            
            
            double v34a=(v1+v2)/2;
            ExtMapBuffer2[i]=v34a;//  JPY            
            
            
            if(v34a==0)continue;
            ExtMapBuffer3[i]=v12a/v34a;
            
            
            m1=iMA("GBPJPY",0,90,0,0,0,bn5);            
            
            if(m1==0)continue;
            ExtMapBuffer4[i]=iClose("GBPJPY",0,bn5)/m1;
            
            
            
         }
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+